/*---------------------------------------------------------------------------*\

    FILE....: hostdsp.h
    TYPE....: C+ Functions
    AUTHOR..: David Rowe
    DATE....: 13/5/02

    This modules simulates the "DSP" for host processing cards.

\*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*\

         Voicetronix Voice Processing Board (VPB) Software

         Copyright (C) 1999-2002 Voicetronix www.voicetronix.com.au

         This library is free software; you can redistribute it and/or
         modify it under the terms of the GNU Lesser General Public
         License as published by the Free Software Foundation; either
         version 2.1 of the License, or (at your option) any later version.

         This library is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty of
         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
         Lesser General Public License for more details.

         You should have received a copy of the GNU Lesser General Public
         License along with this library; if not, write to the Free Software
         Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	 USA

\*---------------------------------------------------------------------------*/

#ifndef __HOSTDSP__
#define __HOSTDSP__

#include "contypes.h"
#include "vpbreg.h"
#include "generic.h"
#include "hdaport.h"

typedef struct {
	int		state;
	unsigned long	time;
	int		one_ring;
} RINGGEN;
                                                                                                                             
typedef struct {
	int		state;
	unsigned long	start_time;
	unsigned long	duration;
} FLASH;

struct os_chan {
	RINGGEN ringgen;
	void	*dtmf_dec;
	int	hook_state;
	long	hook_time;
	int	ring;
	FLASH	flash;
};

/*-------------------------------------------------------------------------*\

			    FUNCTION HEADERS

\*-------------------------------------------------------------------------*/

class OpenSwitch
{
private:
	void osHostDSPOpen(void);
	void osHostDSPClose(void);
	void osOpenPorts(void);
	void osClosePorts(void);
public:
	VPBREG	*vr;
	int	finish;
	int	active_threads;
	hdaport	*hdaports;
	void	**toneg; 
//	void	**dtmf_dec;
//	int	*hook_state;
//	long	*hook_time;
//	RINGGEN	*ringgen;
//	int	*ring;
//	FLASH	*flash;
	int	total_ringing;
	GENERIC_CRITICAL_SECTION mutex;
	OpenSwitch(VPBREG *vr);
	~OpenSwitch();
};


//void HostDSPOpen(int numbd, VPBREG *vr);
//void HostDSPClose();
void HostDSPSetupPlay(int h);
int Write_Iic( unsigned short card, unsigned short addr, unsigned short length, unsigned short *buf);
int Read_Iic( unsigned short card, unsigned short addr, unsigned short length, unsigned short *buf);
#endif

