/*---------------------------------------------------------------------------*\

    FILE....: VPBCONF.CPP
    TYPE....: C++ Console program
    AUTHOR..: Jean-Michel Dault
    DATE....: 20/08/03

    This program gets the model and ports on an OpenSwitch board.

\*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*\

         Voicetronix Voice Processing Board (VPB) Software

         Copyright (C) 1999-2003, 2006 Voicetronix www.voicetronix.com.au

         This library is free software; you can redistribute it and/or
         modify it under the terms of the GNU Lesser General Public
         License as published by the Free Software Foundation; either
         version 2.1 of the License, or (at your option) any later version.

         This library is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty of
         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
         Lesser General Public License for more details.

         You should have received a copy of the GNU Lesser General Public
         License along with this library; if not, write to the Free Software
         Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
	 USA

\*---------------------------------------------------------------------------*/

#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "vpbapi.h"
#include "verbose.h"
#include "hdaport.h"

#define BANKB		12
#define MAX_BOARDS	12


int main(int argc, char *argv[]) {

	VPB_CARD_INFO   *pcard_info[MAX_BOARDS], card_info[MAX_BOARDS];
	int		card_type[MAX_BOARDS];
	int 		i,j,h[MAX_BOARDS],x;
	int		tmp=0;
	int		numboards;
	int 		ports,port_count;

	//	verbose(1);
	//	vpb_seterrormode(VPB_DEVELOPMENT);

	h[0]=vpb_open(0,0);
	numboards=vpb_get_num_cards();
	printf("\nCards detected:%d\n\n",numboards);

	for(i=0;i<numboards;i++) {
		if (i!=0) h[i]=vpb_open(i,0);
		printf("BOARD %d\n",i);
		port_count=ports=vpb_get_ports_per_card(i);
		pcard_info[i]=&card_info[i];
		vpb_get_card_info(i,pcard_info[i]);
		card_type[i] = vpb_get_type(h[i]);
		switch(card_type[i]){
			case VPB_V4PCI:
			case VPB_V4LOG:
			case VPB_V6PCI:
			case VPB_V12PCI:
				printf("MODEL         : %s\n",card_info[i].model);
				printf("DATE          : %s\n",card_info[i].date);
				printf("REVISION      : %s\n",card_info[i].rev);
				printf("SERIAL NUMBER : %s\n",card_info[i].sn);
				break;
			default:
				printf("MODEL         : %s\n",card_info[i].model);
				break;
		}
		printf("STATIONS[%d]: ",i);
		if (VPB_FXS == vpb_get_port_type(h[i]))
			printf("%d ",0+tmp);
		for(j=1;j<ports;j++) {
			x = vpb_open(i,j);
			if (VPB_FXS == vpb_get_port_type(x))
				printf("%d ",j+tmp);
			vpb_close(x);
		}
		printf("\n");
		printf("TRUNKS[%d]: ",i);
		if (VPB_FXO == vpb_get_port_type(h[i]))
			printf("%d ",0+tmp);
		for(j=1;j<ports;j++) {
			x = vpb_open(i,j);
			if (VPB_FXO == vpb_get_port_type(x))
				printf("%d ",j+tmp);
			vpb_close(x);
		}
		printf("\n =============================================================\n");
		tmp+=vpb_get_ports_per_card(i);
	}
	for(i=0;i<numboards;i++) {
		vpb_close(h[i]);
	}

	return 0;
}

